# tkWWW tk interface to World Wide Web
# Copyright (C) 1992 Joseph Wang (joe@athena.mit.edu)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

# ******* The Home Page

set tkWWWHomePage http://uu-gna.mit.edu:8001/uu-gna/index.html


proc tkW3HtSetName {address title} {
}
 
proc tkW3HtBeginDoc {} {
}


proc tkW3HtAdd {string {styles ""}} {
}

proc tkW3HtBegin {stack elem} {
}

proc tkW3HtEnd {stack elem} {
}

proc tkW3HtEndDoc {} {
}

proc tkW3HtSetNextId {id} {
}

proc tkW3HtAddBul {type} {
}

proc tkW3HtSetImg {source {ismap 0}} {
}

proc tkW3HtSetInd {href} {
}

proc tkW3HtSetBase {href} {
}


proc tkW3HtBlankLines {n} {
}

proc tkW3HtListPop {in_list} {
    upvar $in_list list
    set index [llength $list]
    incr index -1
    set item [lindex $list $index]
    incr index -1
    set list [lrange $list 0 $index]
    return $item
}

proc tkW3HtListLast {in_list} {
    upvar $in_list list
    set index [llength $list]
    incr index -1
    lindex $list $index
}

proc tkW3HtButtonPress {w loc b tm} {
    global tkW3HtPage tkW3HtText
    set tag_list [.f.msg tag names $loc]
    set index [lsearch -regexp $tag_list  {^i[0-9]+$}]
 
    if {$index == -1} {
	set index [lsearch -regexp $tag_list  {^h[0-9]+$}]
    }
    if {$index != -1} {
	# undepress any depressed tag
	if {[string length $tkW3HtText(depressed)]} {
	    $w tag configure $tkW3HtText(depressed) -relief raised
	    set $tkW3HtText(depressed) {}
	    $w tag raise sel
	    update idletasks
	}
        set tkW3HtText(depressed) [lindex $tag_list $index]
	$w tag configure [lindex $tag_list $index] -relief sunken
        tkW3OutputSetMessage "" 
	update idletasks
    }
    if {$b == 2} {
      set y [lindex [split $loc ,] 1]
      $w scan mark $y
      set tkW3HtText(b2time) $tm
    }
}

proc tkW3HtButtonRelease {w loc b tm} {
    global tkW3HtPage tkW3HtText
    set tag_list [.f.msg tag names $loc]

    # undepress any depressed tag
    if {[string length $tkW3HtText(depressed)]} {
	$w tag configure $tkW3HtText(depressed) -relief raised
        set $tkW3HtText(depressed) {}
        $w tag raise sel
	update idletasks
    }

    # Search for active tag
    # image tags override hypertext anchor tags 
    set index [lsearch -regexp $tag_list  {^i[0-9]+$}]
    if {$index == -1} {
	set index [lsearch -regexp $tag_list  {^h[0-9]+$}]
    }

    if {$index != -1} {
	set tag [lindex $tag_list $index]
	$w tag configure $tag -relief raised
	update idletasks
	regexp {([hi])([0-9]+)} $tag {} tag_type i
	switch -- $tag_type {
	    "i" {
		    switch -- $b {
			"1" {
			    tkW3NavigateRecordAndGoto \
				$tkW3HtPage(image.$i) {} \
				$tkW3HtPage(image.anchor.$i) \
				$tkW3HtPage(image.ismap.$i)
			}
			"2" {
			    tkW3NavigateClone $tkW3HtPage(image.$i) \
				$tkW3HtPage(image.anchor.$i) \
				$tkW3HtPage(image.ismap.$i)
			}
			"3" {
			    tkW3EditChangeImage $i
			}
		    }
		}
	    
	    "h" {
		switch -- $b {
		    "1" {
			tkW3NavigateRecordAndGoto $tkW3HtPage(anchor.href.$i)
		    }
		    "2" {
			tkW3NavigateClone $tkW3HtPage(anchor.href.$i)
		    }
		    "3" {
			tkW3EditSetupAnchorDialog $w $i
		    }
		}
	    }
	}
    } else {
      if {$b == 2} {
	if {[expr $tm-$tkW3HtText(b2time)]<500} {
	  if {![catch {selection get} s]} {tkW3EditInsert $w $s}
	}
      }
    }
}

proc tkW3HtProgress {msg} {
    tkW3OutputSetMessage $msg
    update idletasks
}

proc tkW3HtAlert {msg} {
    if {[regexp {404} $msg] &&
	[regexp {file:[^ 
]+} $msg page_name ]} {
	    if {[DLG:msg "$msg
Do you wish to create $page_name?" question "Yes" "No"]==1} {
    tkW3FileNewPage $page_name
} {
    tkW3HistoryRestore
}
	    return
	}
	# Undo any changes we have made to the history list
    tkW3HistoryRestore
    # Tell the user about the error
    tkW3OutputError $msg
}

proc tkW3HtStartElement {tag args} {
}

proc tkW3HtEndElement {tag args} {
}

proc tkW3HtAddEntity {entity} {
}

proc tkW3HtHandleOptions {record arglist} {
}









