#include <TkWWWCmds.h>
#include <TkWWWBitmap.h>
#include <Tix.h>
#include <tcl.h>
#include <tk.h>

extern char binary_init_tcl[];
extern char annotate_tcl[], bookmarks_tcl[], dialog_tcl[];
extern char edit_anchor_tcl[], edit_generate_tcl[], edit_modified_tcl[];
extern char edit_selection_tcl[], edit_tcl[], editwin_tcl[];
extern char file_tcl[], font_tcl[];
extern char grpan_tcl[], help_tcl[], history_tcl[];
extern char hypertext_tcl[], image_tcl[], init_tcl[];
extern char main_tcl[], menu_tcl[], rcs_tcl[], navigate_tcl[];
extern char output_tcl[], pan_tcl[];
extern char parse_args_tcl[], telnet_tcl[], tix_tcl[];
extern char library_button_tcl[], library_dialog_tcl[], library_entry_tcl[];
extern char library_focus_tcl[], library_init_tcl[], library_listbox_tcl[];
extern char library_menu_tcl[], library_obsolete_tcl[];
extern char library_optionMenu_tcl[];
extern char library_parray_tcl[], library_scale_tcl[], library_scrollbar_tcl[];
extern char library_tearoff_tcl[], library_text_tcl[], library_tk_tcl[];
extern char library_tkerror_tcl[];


/*
 * The following variable is a special hack that allows applications
 * to be linked using the procedure "main" from the Tk library.  The
 * variable generates a reference to "main", which causes main to
 * be brought in from the library (and all of Tk and Tcl with it).
 */

extern int main();
int *tclDummyMainPtr = (int *) main;

#define EXEC_STRING(s) if ((result=Tcl_Eval(interp,s)) != TCL_OK) \
    return (result);

int 
Tcl_AppInit(interp) 
     Tcl_Interp *interp;
{
  Tk_Window main;
  int result;

  if (WWW_AppInit(interp) == TCL_ERROR) {
    return TCL_ERROR;
  }

  if (WWW_BitmapInit(interp) == TCL_ERROR) {
    return TCL_ERROR;
  }

  /*The following must be executed first */
  EXEC_STRING(binary_init_tcl);
  EXEC_STRING(library_init_tcl);
  EXEC_STRING(library_tk_tcl);
  EXEC_STRING(library_button_tcl);
  EXEC_STRING(library_dialog_tcl);
  EXEC_STRING(library_entry_tcl);
  EXEC_STRING(library_focus_tcl);
  EXEC_STRING(library_listbox_tcl);
  EXEC_STRING(library_menu_tcl);
  EXEC_STRING(library_obsolete_tcl);
  EXEC_STRING(library_optionMenu_tcl);
  EXEC_STRING(library_parray_tcl);
  EXEC_STRING(library_scale_tcl);
  EXEC_STRING(library_scrollbar_tcl);
  EXEC_STRING(library_tearoff_tcl);
  EXEC_STRING(library_text_tcl);
  EXEC_STRING(library_tkerror_tcl);
  EXEC_STRING(init_tcl);

  if (Tix_AppInit(interp) == TCL_ERROR) {
    return TCL_ERROR;
  }
  EXEC_STRING(tix_tcl);

  /* Load the modules */
  EXEC_STRING(annotate_tcl);
  EXEC_STRING(bookmarks_tcl);
  EXEC_STRING(dialog_tcl);
  EXEC_STRING(edit_anchor_tcl);
  EXEC_STRING(edit_generate_tcl);
  EXEC_STRING(edit_modified_tcl);
  EXEC_STRING(edit_selection_tcl);
  EXEC_STRING(edit_tcl);
  EXEC_STRING(editwin_tcl);
  EXEC_STRING(file_tcl);
  EXEC_STRING(font_tcl);
  EXEC_STRING(grpan_tcl);
  EXEC_STRING(help_tcl);
  EXEC_STRING(history_tcl);
  EXEC_STRING(hypertext_tcl);
  EXEC_STRING(image_tcl);
  EXEC_STRING(menu_tcl);
  EXEC_STRING(navigate_tcl);
  EXEC_STRING(output_tcl);
  EXEC_STRING(pan_tcl);
  EXEC_STRING(parse_args_tcl);
  EXEC_STRING(rcs_tcl);
  EXEC_STRING(telnet_tcl);


  /*execute this last */
  EXEC_STRING(main_tcl);

  return (TCL_OK);
}
