## annotation.tcl: Procedures for handling annotations
## ================
## Copyright (C) 1993 
## Globewide Network Academy
## Macvicar Institute for Educational Software Development
##
## See the file COPYRIGHT for conditions
##
## The format of the annotations is that of Xmosaic by Marc Andersen

## Add annotation
proc tkW3AnnotateAdd {} {
    set w .annotate_dialog
    set address [tkW3NavigateGetAddress]
    tkW3AnnotateCreateEditor $w "
tkW3PanNewPan $address \[DLG:get_entry_value $w 2\] \
 \[DLG:get_entry_value $w 1\] \[$w.text get 0.0 end\]
tkW3ConfigDisplay" ""
    set author [exec whoami]
    DLG:set_entry_value .annotate_dialog 1 $author 
    DLG:set_entry_value .annotate_dialog 2 "Annotation by $author"
    .annotate_dialog show
}

## Edit annotation
proc tkW3AnnotateEdit {} {
    set w .annotate_dialog
    set address [tkW3NavigateGetAddress]
    if {[tkW3PanIsEditablePan $address]} {
	set list [tkW3PanGrokPanPieces $address]
	tkW3AnnotateCreateEditor $w "
tkW3PanModifyPan [lindex $list 0] \[DLG:get_entry_value $w 2\]\
   \[DLG:get_entry_value $w 1\] \[$w.text get 0.0 end\]
tkW3NavigateUncache $address
tkW3NavigateGoto $address" "tkW3PanDeletePan [lindex $list 0]"

	DLG:set_entry_value $w 1 [lindex $list 2]
	DLG:set_entry_value $w 2 [lindex $list 1]
	.annotate_dialog.text insert 0.0 [lindex $list 3]

	$w show
    }
}

## Create the annotation editor
proc tkW3AnnotateCreateEditor {w command delete_command} {
    tixDialogShell $w
    pack append $w \
	[DLG:draw_entries $w.frame {"Annotation Author:" "Annotation Title:"}] \
	{top expand fill} \
	[tixDlgBtns $w.btns ] {bottom fill} \
	[label $w.label \
	   -text "Please type your comments below" ] { fillx top} \
	[text $w.text ] {expand fill top}

    $w.btns add annotate -command "$command ; $w popdown" -label "Annotate"
    $w.btns add delete -command "$delete_command ; $w popdown" \
	-label "Delete"
    $w.btns add dismiss -command "$w popdown" -label "Dismiss"
}

## Display annotations 
proc tkW3AnnotateDisplay {} {
    tkW3PanDisplayAnnotations [tkW3NavigateGetAddress]
}

