# THIS FILE REQUIRES tk3.3 or greater.

# Build a message dialog
# Calling arguments are
# parent - dialog to be centered on
#        - "" means center on screen
# w - name of dialog
# msg - message
# bitmap - bitmap to be displayed
# args - button list

proc DLG:msg {msg bitmap args} {
    set done "DLGdone"
    global $done
    set $done 0
    set w .msg

    set oldFocus [focus]

    tixDialogShell $w    
    tixDlgBtns $w.btns
    set i 1
    foreach item $args {
	$w.btns add b$i -text $item \
	    -command "global $done; set $done $i"
	incr i
    }

    pack append $w \
	[DLG:draw_icon_msg $w.top $bitmap $msg] {top fill} \
	$w.btns {bottom fill}

    $w popup
    focus $w
    grab $w
    tkwait variable $done
    focus $oldFocus
    destroy $w
    return "[set $done]"
}

# Draw a frame with an icon and a message
proc DLG:draw_icon_msg {w bitmap text} {
    frame $w -relief raised -bd 1

    message $w.msg -aspect 1500 -text $text 
    pack $w.msg -in $w -side right -expand 1 -fill both -padx 5m -pady 5m
    if {$bitmap != ""} {
	pack [label $w.bitmap -bitmap $bitmap] \
	    -side left -padx 5m -pady 5m
    }
    return $w
}


# Add bindings to the entries
