## font.tcl Procedures for changing fonts
## ==============
## Copyright (C) 1992-1993
## Globewide Network Academy
## Macvicar School of Education and Technology
##
## See the file COPYRIGHT for conditions

## The procedures in this file are responsible for font display

## Conventions:
##   All procedures in this file begin with tkW3Font

proc tkW3FontInitialize {} {
    global tkW3ConfigFont tkW3ConfigFontList tkW3ConfigFontDefault
    tkW3FontHandlerClass .fonts -target .f.msg 

    foreach item $tkW3ConfigFontList {
	.fonts add_font [lindex $item 0 ] [lindex $item 1] \
	    $tkW3ConfigFont([lindex $item 0])
    }
    .fonts set_font $tkW3ConfigFontDefault
}

tixWidgetClass tkW3FontHandlerClass {
    -superclass tixDialogShell
    -classname TixFontHandlerClass
    -shortname tkW3FHC
    -method {set_font add_font set_selected}
    -flag {
	-target
    }
    -configspec {
	{-target target Target {}}
    }
}

proc tkW3FHC::ConstructWidget {w} {
    upvar #0 $w data
    tixChainMethod $w ConstructWidget

    set data(font_name) ""

    set data(w:btns) [tixDlgBtns $w.btns]
    $data(w:btns) add ok -command "$w set_font
$w popdown" -text "OK"
    $data(w:btns) add apply -command "$w set_font" -text "Apply"
    $data(w:btns) add dismiss -command "$w popdown" -text "Dismiss"
    

    set data(w:tframe) [frame $w.tframe]
    pack $data(w:tframe) -side top -expand yes -fill both
    pack $data(w:btns) -side bottom -fill both
}

proc tkW3FHC::add_font {w name label font_list} {
    upvar #0 $w data

    pack [radiobutton $data(w:tframe).$name \
	  -text $label -relief flat \
          -command "$w set_selected $name" \
	      -anchor w ] -side top -fill x
    set data(fonts.$name) $font_list
}

proc tkW3FHC::set_selected {w name} {
    upvar #0 $w data
    set data(font_name) $name
}

proc tkW3FHC::set_font {w args} {
    upvar #0 $w data

    if {$args == ""} {
	set font_name $data(font_name) 
    } {
	set font_name [lindex $args 0]
    }

    foreach font $data(fonts.$font_name) {
	set style [lindex $font 0]
	if {$style == ""} {
	    $data(-target) configure -font [lindex $font 1]
	} else {
	    $data(-target) tag configure $style -font [lindex $font 1]
	}
    }
    $data(-target) tag configure U -underline true
    set data(font_name) $font_name
}

	
    
