## help.tcl tkW3 help facility
## ==============
## Copyright (C) 1992-1993
## Globewide Network Academy
## Macvicar School of Education and Technology
##
## See the file COPYRIGHT for conditions

## Conventions:
##   all global visible objects in this file should begin with 
##   tkW3Help

proc tkW3HelpSendMailToDeveloper {} {
    global tkW3Version tkW3ConfigMailList
    tkW3NavigateClone mailto:$tkW3ConfigMailList(bugs)
}


proc tkW3HelpNotAvailable {} {
    DLG:msg "Sorry, This feature is not available yet" info "OK"
}

proc tkW3HelpNoHelp {} {
    DLG:msg "Sorry, Help is not available yet" info "OK"
}

proc tkW3HelpAddToMailingList {} {
    global tkW3Version tkW3ConfigMailList
    tkW3OutputSetMessage "Sending request to $tkW3ConfigMailList(request)"
    tkW3ConfigSendMail $tkW3ConfigMailList(request) \
	"Subscribe $tkW3Version" "subscribe tkwww"
    tkW3OutputSetMessage "Request sent to $tkW3ConfigMailList(request)"
}

proc tkW3HelpRemoveFromMailingList {} {
    global tkW3Version tkW3ConfigMailList
    tkW3OutputSetMessage "Sending request to $tkW3ConfigMailList(request)"
    tkW3ConfigSendMail $tkW3ConfigMailList(request) \
	"Remove $tkW3Version" "unsubscribe tkwww"
    tkW3OutputSetMessage "Request sent to $tkW3ConfigMailList(request)"
}

proc tkW3HelpGetTopic {topic} {
    if {$topic != "no_help"} {
	global tkW3ConfigHelpRoot
	tkW3NavigateClone $tkW3ConfigHelpRoot/$topic.html
    } {
	DLG:msg "Sorry: No help is available on this topic yet" info "OK"
    }
}


proc tkW3HelpAbout {} {
    global tkW3Version tkW3ConfigLogo tkW3ConfigMailList

# I insert the \n so that the blank lines don't get removed when this 
# is run through tcl2c

    if {[DLG:msg "
tkWWW Version $tkW3Version
by Joseph Wang (joe@mit.edu)
\nCopyright \251 1992-1995
Globewide Network Academy (GNA)
Macvicar School of Education and Technology (MSET)
\nUnder the terms of the GNU Public License Version 2.0
\nThe tkWWW mailing list is $tkW3ConfigMailList(list)
Send subscription requests to $tkW3ConfigMailList(request)
Send bug reports to $tkW3ConfigMailList(bugs)
"  $tkW3ConfigLogo "OK" "Credits"] == 2} {
    tkW3HelpGetTopic credits
}
}

