## history.tcl: history for tkWWW  user interface
## ==============
## Copyright (C) 1993
## Globewide Network Academy
## Macvicar School of Education and Technology
##
## See the file COPYRIGHT for conditions

proc tkW3HistoryInitialize {} {
    tkW3HistoryClass tkw3history -goto_command tkW3NavigateGoto
}

tixClass tkW3HistoryClass {
    -superclass {}
    -classname TkW3HistoryClass
    -shortname tkW3History
    -method {record  restore popup goto_selected list_length pop}
    -flag {-goto_command}
    -configspec {
	{-goto_command ""}
    }
}

proc tkW3History::Constructor {w} {
    upvar #0 $w data

    set data(list) ""
    set data(old_list) ""
    set data(widget) .history

    tixDialogShell $data(widget)

    pack append $data(widget) \
	[tixScrolledListbox $data(widget).list] {top expand fill} \
	[tixDlgBtns $data(widget).btns] {bottom fill}
    $data(widget).btns add goto -text "Goto" -command "$w goto_selected"
    $data(widget).btns add dismiss -text "Dismiss" -command "$data(widget) popdown"
    set data(listbox) [$data(widget).list listbox]
    bind $data(listbox) <Double-1> "%W select from \[%W nearest %y\]
$w goto_selected"
    bind $data(widget) <Key-Return> "%W select from \[%W nearest %y\]
$data(widget).btns invoke"
    
}

proc tkW3History::record {w title address 
    {scroll_pos ""} {anchor ""} {ismap ""}} {
    upvar #0 $w data

    set data(old_list) $data(list)

    if {$title == {}} {
	set title "(Address)$address"
    }

    lappend data(list) [list $title $address {} $scroll_pos $anchor $ismap]
}

proc tkW3History::restore {w} {
    upvar #0 $w data
    set data(list) $data(old_list)
}

proc tkW3History::pop {w} {
    upvar #0 $w data
    tkW3HtListPop data(list)
}

proc tkW3History::popup {w} {
    upvar #0 $w data
    $data(listbox) delete 0 end

    foreach item $data(list) {
	$data(listbox) insert end [lindex $item 0]
    }
#    $data(widget).btns focus_in goto
    focus $data(widget).btns
    $data(widget) popup
}

proc tkW3History::goto_selected {w} {
    upvar #0 $w data
    $data(-goto_command) [ \
       lindex [lindex $data(list) [$data(listbox) curselection]] 1]
}

proc tkW3History::list_length {w} {
    upvar #0 $w data
    llength $data(list)
}
