## main.tcl main file for tkWWW  user interface
## ==============
## Copyright (C) 1992-1994
## Globewide Network Academy
## Macvicar School of Education and Technology
##
## See the file COPYRIGHT for conditions 

# If the binary variable is not set, then set it to assume that we are
# not in the binary

if ![info exists tkW3BinaryInBinary] {
    global tkW3BinaryInBinary
    set tkW3BinaryInBinary 0
}

## *************************
## This is the directory containing the source code
## It is retrieved from an environment variable set 
## in the shell script tkWWW
## *************************

# skip this section if we are in a binary

if !$tkW3BinaryInBinary {
    set tkW3SourcePath $env(TK_WWW_SRC_DIR)
    set tkW3TixPath $env(TK_WWW_TIX_DIR)
    set tkW3Version "0.13"

    source $tkW3SourcePath/init.tcl

    # Add the source path to the auto load table
    set auto_path "$tkW3SourcePath $tkW3TixPath $auto_path"
    tixInit -libdir $tkW3TixPath -scheme SGIGray -fontset 14Point
} {
    global TIX_SOURCE_DIR
    tixSetFontset::14Point
    tixSetColorScheme::SGIGray
    tixInitOptionDatabase
    tixSetBinding::TK
    set TIX_SOURCE_DIR "/usr/lib/Tix"
    proc tixGetBitmap {name} {
	return $name
    }
}

option add *waitCursor watch userDefault

## *************************
## Parse the command line
## *************************

tkW3ParseArgs $argv

## *************************
## source user configuration file
## *************************
tixInitialize
catch {source $tkW3ConfigFile}
tkW3OutputInitialize

## *************************
## Window management and Interface code 
## *************************
wm title . "tkWWW"
wm minsize . 0 0
wm iconbitmap . $tkW3ConfigLogo

pack append . \
     [ tkW3MenuMakeMenus .menu $tkW3ConfigMenus ] {top fillx} \
     [ tkW3OutputStyleBarClass .title -orientation vertical \
          -entries {{address "Document Address:"} 
	            {title "Document Title:"}}] {top fillx} \
     [ tkW3OutputMakeToggles .toggles $tkW3ConfigToggles ] {bottom fillx} \
     [ tkW3OutputStyleBarClass .style \
         -entries $tkW3ConfigEntries -combos $tkW3ConfigCombos ] \
          {bottom fillx } \
     [ tkW3OutputMakeButtons .buttons $tkW3ConfigButtons ] {bottom fillx} \
     [ tkW3OutputMakeText .f ] {expand fill } 

## *************************
## Do initializations
## *************************

tkW3NavigateInitialize
tkW3FontInitialize
tkW3FileInitialize
tkW3EditInitialize
tkW3HistoryInitialize
tkW3PanInitialize
tkW3BookmarksInitialize

## *************************
## GUI is created
## Set the welcome message and
## Jump to the first page
## *************************

tkW3NavigateGoto $tkW3ConfigStartPage
