## rcs.tcl RCS module
## ==============
## Copyright (C) 1992-1994
## Globewide Network Academy
## Macvicar School of Education and Technology
##
## See the file COPYRIGHT for conditions

proc tkW3RcsInitialize {} {
    return [tixRcsClass tkW3rcs -term tkW3ConfigExecTerm -interactive true]
}

tixClass tixRcsClass {
    -superclass {}
    -classname TixRcsClass
    -shortname tixRcs
    -method {
	file_exists dir_exists checkout checkin
    }
    -flag {
	-exec -interactive
    }
    -configspec {
	{-exec "exec"}
	{-interactive false}
    }
}

proc tixRcs::file_exists {w file} {
    set directory [file dirname $file]
    set tail [file tail $file]
    expr "[file readable $directory/$tail,v] || 
                  [file readable $directory/RCS/$tail,v]"
}

proc tixRcs::dir_exists {w file} {
    file isdirectory "[file dirname $file]/RCS"
}

proc tixRcs::checkout {w file} {
    upvar #0 $w data
    $data(-exec) "co -l $file"
}

proc tixRcs::checkin {w file} {
    upvar #0 $w data
    $data(-exec) "ci -u $file"
}


