tixWidgetClass tixDlgBtns {
    -superclass tixPrimitive
    -classname  TixDlgBtns
    -shortname  tixDlB
    -method {
	add invoke button buttons
    }
    -flag {
	-orientation -orient -padx -pady
    }
    -static {
	-orientation
    }
    -configspec {
	{-orientation orientation Orientation horizontal}
	{-padx padX Pad 0}
	{-pady padY Pad 0}
    }
    -alias {
	{-orient -orientation}
    }
}

proc tixDlB::InitWidgetRec {w} {
    upvar #0 $w data

    tixChainMethod $w InitWidgetRec

    set data(g:buttons)   {}
}

#----------------------------------------------------------------------
#                           CONFIG OPTIONS
#----------------------------------------------------------------------
proc tixDlB::config-padx {w arg} {
    upvar #0 $w data

    foreach item $data(g:buttons) {
	pack configure $w.$item -padx $arg
    }
}

#----------------------------------------------------------------------
# Methods
#                     WIDGET COMMANDS
#----------------------------------------------------------------------
proc tixDlB::add {w name args} {
    upvar #0 $w data

    eval button $w.$name $args
    if {$data(-orientation) == "horizontal"} {
	pack $w.$name -side left -expand yes -fill y\
	    -padx $data(-padx) -pady $data(-pady)
    } else {
	pack $w.$name -side top -expand yes  -fill x\
	    -padx $data(-padx) -pady $data(-pady)
    }

    # allow for subwidget access
    #
    lappend data(g:buttons) $name
    set data(w:$name) $w.$name

    return $w.$name
}

proc tixDlB::button {w name args} {
    return [tixCallMethod $w subwidget $name $args]
}

proc tixDlB::buttons {w args} {
    return [tixCallMethod $w subwidgets -group buttons $args]
}

#
# call the command
proc tixDlB::invoke {w name} {
    upvar #0 $w data

    $w.$name invoke
}
