#This widget uses xli to paste an arbitrary image file
#It is quite buggy right now

proc tixImage {w args} {
    eval tixInt_CreateWidget $w tixImg TixImage $args
    return $w
}

proc tixImg::CreateClassRec {} {
    global tixImg

    set tixImg(superClass)  tixPmtv

    # OPTIONS
    set tixImg(options)     {-imagefile -output -erroroutput -viewer}
    set tixImg(staticOptions) {}

    # DEFAULT VALUES
    set tixImg(-imagefile)     {-imagefile imageFile ImageFile ""}
    set tixImg(-output)        {-output output Output ""}
    set tixImg(-erroroutput)   {-erroroutput errorOutput 
ErrorOutput "puts stdout"}
    set tixImg(-viewer)        {-viewer viewer Viewer "xli"}
    set tixImg(-fitimage)      {-fitimage fitImage FitImage y}

    set tixImg(-width)        {-width width Width 100}
    set tixImg(-height)       {-height height Height 100}

    set tixImg(methods)       {imageheight imagewidth}
}

proc tixImg::InitWidgetRec {w class className args} {
    upvar #0 $w data
    set data(imageWidth)      0
    set data(imageHeight)     0
}

proc tixImg::ConstructWidget {w} {
    upvar #0 $w data

    tixChainMethod $w ConstructWidget

    if {$data(-imagefile) != {}} {
	tixImg::config-imagefile $w $data(-imagefile)
    }
}

proc tixImg::SetBindings {w} {
    upvar #0 $w data
    bind $w <Map>  "+tixImg::ShowImagefile %W"
    bind $w <Destroy> "+tixImg::ClearColormap %W"
    bind $w <Unmap>  "+tixImg::ClearColormap %W"
}

#----------------------------------------------------------------------
#                           CONFIG OPTIONS
#----------------------------------------------------------------------
#
proc tixImg::config-imagefile {w arg} {
    upvar #0 $w data
    update idletasks
    if {[winfo id $w] != 0x0} {
	set data(-imagefile) $arg
	tixImg::ShowImagefile $w
    }
}



#----------------------------------------------------------------------
#                     WIDGET COMMANDS
#----------------------------------------------------------------------

proc tixImg::imagewidth {w args} {
    upvar #0 $w data
    return $data(imageWidth)
}

proc tixImg::imageheight {w args} {
    upvar #0 $w data
    return $data(imageHeight)
}

#----------------------------------------------------------------------
#                Private functions
#----------------------------------------------------------------------

proc tixImg::ClearColormap {w} {
    upvar #0 $w data
    set window [winfo id $w]
    if {"$window" != "0x0"} {
	set output \
	    [open  "| $data(-viewer) -windowid $window stdin > /dev/null" "w"]
	catch "puts $output \"P1 1 1 0\""
	catch "close $output"
    }
}

proc tixImg::ShowImagefile {w} {
    upvar #0 $w data
    set window [winfo id $w]

    if {$data(-imagefile) == ""} {
	return
    }

    # I don't know why this update is necessary but it is.  If I don't put
    # this line here, I get an invalid window error

    update idletasks

    set output \
	[open  "| $data(-viewer) -windowid $window -private $data(-imagefile)" "r"]

	# Some weirdness is in the following lines
	# I have to trap for error in reading with both the gets and the close
	# I don't know why but I suspect it has something to do with 
	# buffering

    while {1} {
	if [catch {gets $output string} value] {
	    # If there is an error in the output
	    set command $data(-erroroutput)
	    eval [lappend command \
		"Error executing image browser $data(-viewer)"]
	    return
	}

	# If we are done reading things
	if {$value == -1} {
	    break
	}

	regexp {([0-9]+)x([0-9]+)} $string {} \
		data(imageWidth) data(imageHeight)
	if {$data(-output) != ""} {
	    set command $data(-output)
	    eval [lappend command "$string"]
	}
	update idletasks
    } 

    if [catch {close $output} result] {
	# If there is an error in the output
	set command $data(-erroroutput) 
	eval [lappend command "Error executing image browser $data(-viewer)"]
    }
}
