tixWidgetClass tixPopupMenu {
    -superclass tixShell
    -classname  TixPopupMenu
    -shortname  tixPMu
    -method {
	bind
    }
    -flag {
	-state -title 
    }
    -configspec {
	{-state state State normal}
	{-cursor corsor Corsur arrow}
    }
}

proc tixPMu::InitWidgetRec {w} {
    upvar #0 $w data

    tixChainMethod $w InitWidgetRec

    set data(g:clients)   {}
}

proc tixPMu::ConstructWidget {w} {
    upvar #0 $w data

    tixChainMethod $w ConstructWidget

    wm overrideredirect $w 1
    wm withdraw $w

    set data(w:menubutton) [menubutton $w.menubutton -text $data(-title) \
			    -menu $w.menubutton.menu -anchor w]
    set data(w:menu) [menu $w.menubutton.menu]

    pack $data(w:menubutton) -expand yes -fill both
}

proc tixPMu::SetBindings {w} {
    upvar #0 $w data

    tixChainMethod $w SetBindings

    bind $data(w:menubutton) <1>               "tixPMu::Unpost $w"
    bind $data(w:menubutton) <3>               "tixPMu::Unpost $w"
    bind $data(w:menu)       <Unmap>           "+ tixPMu::Unmap $w"
    bind $data(w:menu)       <ButtonRelease-3> {tk_invokeMenu %W}

    bind $w <Destroy> "tixPMu::Destroy $w"
}

proc tixPMu::Post {w client rootx rooty} {
    upvar #0 $w data
    global tk_priv

    # Just in case they were not bound yet ... %% may be inefficient
    #
    foreach submenu [tixDescendants $data(w:menu)] {
	bind $submenu <ButtonRelease-3> {tk_invokeMenu %W}
    }

    set menuWidth [winfo reqwidth $data(w:menu)]
    set width     [winfo reqwidth  $w]
    set height    [winfo reqheight $w]

    if {$width < $menuWidth} {
	set width $menuWidth
    }

    set wx $rootx
    set wy $rooty

    # trick: the following lines allow the popup menu
    # acquire a stable width and height when it is finally
    # put on the visible screen. Advoid flashing
    #
    wm geometry $w +10000+10000
    wm deiconify $w
    raise $w

    update
    wm geometry $w $width\x$height+$wx+$wy
    update

    grab -global $w

    set tk_priv(inMenuButton) $data(w:menubutton) 
    tk_mbButtonDown $data(w:menubutton)
}


proc tixPMu::Unpost {w} {
    upvar #0 $w data

    grab release $data(w:menubutton)
    tk_mbUnpost
    wm withdraw $w
}

proc tixPMu::Unmap {w} {
    upvar #0 $w data

    grab release $data(w:menubutton)
    wm withdraw $w
}

proc tixDestroy {w} {
    upvar #0 $w data

    foreach client $data(g:clients) {
	bind $client <3>         {}
	bind $client <Control-1> {}
    }
}

#----------------------------------------------------------------------
# PublicMethods:
#----------------------------------------------------------------------

proc tixPMu::bind {w args} {
    upvar #0 $w data

    foreach client $args {
	if {[lsearch $data(g:clients) $client] == -1} {
	    lappend data(g:clients) $client
	    bind $client <3> "tixPMu::Post $w $client %X %Y"
	}
    }
}

