# FileType:     (should be one of these: CDF, CODE, DOC)
#
# VersionStart
#
# Package:	## the name of your package goes here          E.g. Tix
# MajorVersion: ## the major version of your package goes here E.g. 4
# MinorVersion: ## the minor version of your package goes here E.g. 0
# PatchLevel:   ## the patch level of your package goes here   E.g. 1
#
# VersionEnd
#
# Description:
#
#
#
# Documentation:
#
#
# StandardSection:
#


# This command declares the class record of the class defined by
# this file. This command is automatically executed when this file is
# loaded. A reference to either tixXXX::AutoLoad or tixSomeClass
#
tixWidgetClass tixStack {
    -superclass tixPrimitive
    -classname  TixStack
    -shortname  tixStk
    -method {
	add next prev
    }
    -flag {
    }
    -static {
    }
    -configspec {
	{-width width Width 300}
	{-height height Height 150}
    }
    -alias {
    }
}

#----------------------------------------------------------------------
# ClassInitialization:
#----------------------------------------------------------------------
proc tixStk::InitWidgetRec {w} {
    upvar #0 $w data

    tixChainMethod $w InitWidgetRec

    set data(g:frames) {}
    set data(top)      -1
}

proc tixStk::ConstructWidget {w} {
    upvar #0 $w data

    tixChainMethod $w ConstructWidget

    set data(w:frame) [frame $w.frame -relief groove -bd 2]
    set bot [frame $w.bot]
    set data(w:next) [button $bot.next -text "Next >>" -width 7\
		      -command "tixStk::Next $w"]
    set data(w:prev) [button $bot.prev -text "<< Prev" -width 7\
		      -command "tixStk::Prev $w"]

    pack $data(w:next) $data(w:prev) -side right -padx 5 -pady 5
    pack $data(w:frame) -expand yes -fill both -padx 5 -pady 5
    pack $bot -fill x

    # kludge. This can be removed when "pack recalculate" is introduced
    #
    pack propagate $w 0
    $data(rootCmd) config -width  $data(-width)
    $data(rootCmd) config -height $data(-height)
}

#----------------------------------------------------------------------
# ConfigOptions:
#----------------------------------------------------------------------

#----------------------------------------------------------------------
# PublicMethods:
#----------------------------------------------------------------------
proc tixStk::add {w item args} {
    upvar #0 $w data

    lappend data(g:frames) [eval frame $w.$item $args]

    if {$data(top) == -1} {
	place $w.$item -in $data(w:frame) -relwidth 1 -relheight 1
	set data(top) 0
    }
    return $w.$item
}

#----------------------------------------------------------------------
# PrivateMethods:
#----------------------------------------------------------------------

