# Undocumented command. Don't use it.
#
proc tixDefOption {classes specs} {
    foreach class $classes {
	foreach spec $specs {
	    # Trick.
	    # Since the spec is quoated by curly brackets,
	    # they were not substituted. The uplevel command
	    # force this to be evaluted in the previous level,
	    # so that $spec can be substituted.
	    #
	    uplevel 1 eval option add *$class$spec userDefault
	}
    }
}


proc tixInitOptionDatabase {} {

    # This command is quite important. Without it the options for
    # the subwidgets inside TIX widgets will be completely crazy

    global tixOption

    # Specific to all TK Widgets

    set tixWidgets {
	TixControl
	TixDlgBtns
	TixLabelFrame
	TixMwmClient
	TixPanedWindow
	TixPopupMenu
	TixScrolledListbox
	TixSelect
	TixStdDlgBtns
	TixCombobox
	TixFileSelectbox
    }

    set tkWidgets {
	Button
	Canvas
	Checkbutton
	Entry
	Frame
	Label
	Listbox
	Radiobutton
	Menu
	Menubutton
	Scale
	Scrollbar
	Text
    }

    set strictTK 0
    
    if {$strictTK} {
	# Just want to set options for TIX widgets
	#
	set allWidgets $tixWidgets
    } else {
	# Set options for both TK and TIX widgets
	#
	set allWidgets [concat $tkWidgets $tixWidgets ]
    }

    # general stuff, everything gets these defaults unless otherwise specified
    #-------------------------------------------------------------------------

    tixDefOption $allWidgets {
	{*Font			$tixOption(font)}
	{*Background		$tixOption(bg)}
	{*Foreground		$tixOption(fg)}
	{*font			$tixOption(font)}
	{*background		$tixOption(bg)}
	{*foreground		$tixOption(fg)}
	{*activeBackground	$tixOption(active_bg)}
	{*activeForeground	$tixOption(active_fg)}
	{*disabledForeground	$tixOption(disabled_fg)}
	{*anchor		w}
	{*selectBackground	$tixOption(select_bg)}
	{*selectForeground	$tixOption(select_fg)}
	{*selectBorderWidth	0}
    }

    if {$strictTK == 0}  {
    #----------------------------------------
    # Standard TK Widget Options
    #
    # We set up the options for the TK widgets only if
    # the strictTK option is not selected.
    #----------------------------------------

    tixDefOption {Button} {
	{.borderWidth	$tixOption(border1)}
	{.anchor		c}
    }

    tixDefOption {Checkbutton Radiobutton} {
	{.selector		$tixOption(selector)}
	{.borderWidth		$tixOption(border1)}
    }

    tixDefOption {Entry} {
	{.relief		sunken}
	{.background		$tixOption(input1_bg)}
	{.foreground		black}
	{.insertBackground	black}
    }

    tixDefOption {Label} {
	{.anchor		w}
	{.borderWidth		0}
	{.font              	$tixOption(bold_font)}
    }

    tixDefOption {Listbox} {
	{.background	$tixOption(dark1_bg)}
	{.relief		sunken}
    }

    tixDefOption {Menu} {
	{*font		$tixOption(menu_font)}
	{*selector		$tixOption(selector)}
    }

    tixDefOption {Menubutton} {
	{*font		$tixOption(menu_font)}
    }

    tixDefOption {Scale} {
	{.foreground	$tixOption(fg)}
	{.activeForeground	$tixOption(bg)}
	{.background	$tixOption(bg)}
	{.sliderForeground	$tixOption(bg)}
	{.sliderBackground	$tixOption(dark1_bg)}
	{.font		$tixOption(italic_font)}
    }

    tixDefOption {Scrollbar} {
	{.foreground	$tixOption(bg)}
	{.activeForeground	$tixOption(bg)}
	{.background	$tixOption(dark1_bg)}
	{.relief		sunken}
    }

    tixDefOption {Text} {
	{.background	$tixOption(input1_bg)}
	{.relief		sunken}
	{.borderWidth	$tixOption(border1)}
    }
    }

    #----------------------------------------------------------------------
    # TIX WIDGETS
    #----------------------------------------------------------------------

    tixDefOption $tixWidgets {
	{.label.anchor			c}
	{.label.borderWidth		0}
	{.label.padX              	0}
	{.label.padY              	0}
    }

    tixDefOption {TixBalloon} {
	{*background 			#ffff60}
	{*foreground 			black}
	{*borderWidth 			0}
	{.borderWidth 			1}
	{.background 			black}
    }

    tixDefOption {TixBitmapButton} {
	{*label.font 			$tixOption(font)}
    }

    tixDefOption {TixControl} {
	{.borderWidth 			0}
	{.value 			0}
	{.value 			0}
	{*Button.borderWidth		$tixOption(border1)}
	{*Button.anchor			c}
	{*entry.background		$tixOption(input1_bg)}
	{*entry.foreground		black}
	{*entry.relief			sunken}
	{*entry.width			5}
	{*entry.insertBackground	black}
	{*label.anchor			e}
	{*label.borderWidth		0}
	{*label.font              	$tixOption(bold_font)}
    }

    # DLG_BTNS
    #
    tixDefOption {TixDlgBtns TixStdDlgBtns} {
	{.borderWidth 	1}
	{.relief 	raised}
	{.padX 		10}
	{.padY 		10}
	{*Button.background $tixOption(bg)}
	{*Button.anchor	c}
    }


    # LABEL_FRAME
    #
    tixDefOption {TixLabelFrame} {
	{*label.font 	$tixOption(bold_font)}
	{*label.anchor 	w}
	{*frame.relief 	groove}
	{.borderWidth 	2}
	{.padX 		2}
	{.padY 		2}
	{.anchor 	sw}
    }

    # MwmClient
    #
    tixDefOption {TixMwmClient} {
	{*title.font	$tixOption(menu_font)}
    }

    # OPTION_MENU
    #
    tixDefOption {TixOptionMenu} {
	{*menubutton.font	$tixOption(font)}
	{*selector.borderWidth	2}
	{*selector.relief	raised}
	{*selector.width	10}
	{*selector.height	6}
    }

    # PANED_WINDOW
    #
    tixDefOption {TixPanedWindow} {
	{.handleActiveBg $tixOption(active_bg)}
	{.seperatorBg    $tixOption(bg)}
	{.handleBg       $tixOption(bg)}
    }

    # POPUP MENU
    #
    tixDefOption {TixPopupMenu} {
	{*menubutton.background $tixOption(dark1_bg)}
    }

    # SCROLLED_LISTBOX
    #
    tixDefOption {TixScrolledListbox} {
	{*Scrollbar.foreground	$tixOption(bg)}
	{*Scrollbar.background	$tixOption(dark1_bg)}
	{*Scrollbar.relief	sunken}
	{*Scrollbar.width	15}
	{*listbox.relief	sunken}
	{*listbox.background	$tixOption(dark1_bg)}
    }


    # SELECT
    #
    tixDefOption {TixSelect} {
    }

    # NON ALPHABETICAL ORDER WIDGETS

    # Since TK's option database follows the order-of-declaration rule, not
    # specific-vs-general rule, the options of the widgets below depends on
    # the options of the widget above, so their options must be defined here

    # COMBOBOX
    tixDefOption {TixCombobox} {
	{*Entry.font				$tixOption(font)}
	{*Entry.relief				sunken}
	{*Entry.background			$tixOption(input1_bg)}
	{*Entry.foreground			black}
	{*Entry.insertBackground		black}
	{*TixScrolledListbox.scrollbar		y}
	{*TixScrolledListbox.listbox.geometry	8x8}
	{*shell.borderWidth			2}
	{*shell.relief				raised}
	{*shell.cursor				arrow}
    }

    # FILE_SELECT_BOX

    tixDefOption {TixFileSelectbox} {
	{.relief			raised}
	{.borderWidth 			1}
	{*Label.anchor			w}
	{*Label.borderWidth		0}
	{*Label.font            	$tixOption(bold_font)}
	{*TixCombobox*scrollbar		auto}
	{*TixScrolledListbox.scrollbar	auto}
    }
}
